	subroutine vpwpwur(v0,cosgamma,singamma,z1mp,x1mp,z1np,x1np,
     .                     w0,u0,r0)
c
c  ------------------------------------------------------------------------
c	draw vplot
c
c						-- (c) Lin Zhang       4/92
c  ------------------------------------------------------------------------
c
c     Name		I/O		Explanation
c
c	v0		I		velocity at the origin
c	cosgamma	I		rotation parameter
c	singamma 	I		rotation parameter
c	z1mp,x1mp,z1np,x1np I		normal point coordinates
c	w0,u0,r0	I		ray parameters at the origin
c
c  ------------------------------------------------------------------------
c
	implicit undefined (a-z)

	real v0,w0,u0,r0
	integer npoint,ipoint
	real cosgamma,singamma,z1mp,x1mp,z1np,x1np
	real xt,zt,x2,z2,x1m,z1m,x1n,z1n,xzsize
	real theta1,theta2,theta,dtheta1,dtheta2,rr

	npoint = 128
	xzsize = 1.
	x1m = x1mp*cosgamma+z1mp*singamma
	z1m = -x1mp*singamma+z1mp*cosgamma
	x1n = x1np*cosgamma+z1np*singamma
	z1n = -x1np*singamma+z1np*cosgamma

	call vpcolor(2)
	call vpfat(6)
	zt = 0.12*xzsize*w0*v0
	xt = 0.12*xzsize*u0*v0
	call vpuarrow(0.,0.,xt,zt,0.03*xzsize)
	rr = abs(r0)
	z2 = -w0*v0*r0
	x2 = -u0*v0*r0
	theta1 = atan2(-x2,-z2)-atan2(x1m-x2,z1m-z2)
	theta2 = atan2(x1n-x2,z1n-z2)-atan2(-x2,-z2)
	dtheta1 = abs(theta1)
	dtheta2 = abs(theta2)
	theta1 = atan2(-x2,-z2)-dtheta1
	theta2 = atan2(-x2,-z2)+dtheta2
	xt = x2+rr*sin(theta1)
	zt = z2+rr*cos(theta1)
	call vpumove(xt,zt)
	do ipoint = 1,npoint
	   theta = theta1+ipoint*(theta2-theta1)/npoint
	   zt = z2+rr*cos(theta)
	   xt = x2+rr*sin(theta)
	   call vpudraw(xt,zt)
	enddo

	return
	end
